import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { Form, Row, Col, Input, notification } from 'antd'
import './index.scss'

const { TextArea } = Input

class MainSearch extends Component {
  static propTpyes = {
    inputSubmit: PropTypes.func // 回车事件
  }

  componentDidMount () {
    try {
      let _form = document.getElementById('config')
      if (_form && _form.select) {
        _form.select()
      }
    } catch (e) {
      console.warn('Form focusing error！')
    }
  }

  handleConfirm = () => {
    // 表单提交时检查输入值是否正确
    return new Promise((resolve, reject) => {
      this.props.form.validateFieldsAndScroll((err, values) => {
        if (!err) {
          let _config = values.config

          try {
            _config = JSON.parse(window.decodeURIComponent(window.atob(_config)))
          } catch (e) {
            notification.warning({
              top: 92,
              message: '解析错误',
              duration: 5
            })
            _config = ''
          }

          if (_config) {
            resolve(_config)
          }
        } else {
          reject(err)
        }
      })
    })
  }

  render() {
    const { getFieldDecorator } = this.props.form
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 24 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 24 }
      }
    }
    return (
      <Form {...formItemLayout} className="config-paste-form">
        <Row gutter={24}>
          <Col span={24}>
            <Form.Item label="配置信息" className="textarea">
              {getFieldDecorator('config', {
                initialValue: '',
                rules: [
                  {
                    required: true,
                    message: '请输入配置信息!'
                  }
                ]
              })(<TextArea autoSize={{ minRows: 6, maxRows: 6 }} onPressEnter={() => this.props.inputSubmit && this.props.inputSubmit()}/>)}
            </Form.Item>
          </Col>
        </Row>
      </Form>
    )
  }
}

export default Form.create()(MainSearch)